/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



//
// rewritten by Jan Woetzel Nov/2003
//

#include <limits.h>
#include <iostream>
#include <cmath>

#include <Base/Debug/TimeMeasure.hh>

using namespace BIAS;
using namespace std;

int main(){
  std::cout<<"starting."<<std::endl;
  
  const float loops=1E7;

  TimeMeasure tc;
  tc.Start();
  float sum=0;
  for (int x=0; x<loops; x++){
    sum+=10.0f*(float)x;
  };
  tc.Stop();
  tc.Print();
#ifdef __i386__
  tc.PrintCycleCount();
#endif

  tc.Reset();

  tc.Start();
  for (int x=0; x<loops; x++){
    sum+=3.0f*(float)x;
  }
  tc.Stop();
  tc.Print();
#ifdef __i386__
  tc.PrintCycleCount();
#endif

  return 0;
}


