#include <iostream>

#include <Base/Image/ImageBase.hh>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>

#ifndef BIAS_HAVE_IMAGEMAGICKLIB
#  error BIAS_HAVE_IMAGEMAGICKLIB not defined. Recompile BIAS with ImageMagick
#endif


using namespace std;
using namespace BIAS;

/**
 @example ExampleImageMagickIO.cpp
 How to use the ImageMagick IO routines directly 
 instead of all vailable routines from BIAS::ImageIO::Load
 @author Jan Woetzel
*/


void usage(int argc, char** argv)
{
  cerr<<"usage: ";
  if (argc>0) cerr<<argv[0]<<" <image-filename>"<<endl;
}

int main(int argc, char** argv)
{ 
  if (argc!=2) {
    usage(argc, argv);
    return 0;
  };
  
  BIAS::Image<unsigned char> img;
  BIASASSERT(argc>1);
  string filename=argv[1];
  
  // BIAS::ImageIO::ImportImage(filename, img);
  BIAS::ImageIO::ImportMagickPPAutoconvert(filename, img);
  
  BIAS::ImageIO::ExportMagickPP("out_Magick.png", img);
  BIAS::ImageIO::ExportMagickPP("out_Magick_default.jpg", img);
  // BIAS::ImageIO::WriteMagickPP("out_Magick005.jpg", img, 5);
  // BIAS::ImageIO::WriteMagickPP("out_Magick100.jpg", img, 100);
  
  if (BIAS::ImageIO::ExportImage("out_Magick_ExportImage_FF_png.png", img, BIAS::ImageIO::FF_png ) !=BIAS_IO_SUCCESS){
    BIASERR("an error occurred using ExportImage");
  };
  
  if (BIAS::ImageIO::Write("out_Magick_Write.mip", img ) !=BIAS_IO_SUCCESS){
    BIASERR("an error occurred writing mip");
  };  
  
  cout<<"done"<<endl;
  return 0;
}
