/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 @example viff2mip.cpp
 convert very old Choros .viff format to our internal proprietary .mip image format (depreacted!)
 @author Jan Woetzel
*/


#include <iostream>

#include <Base/Image/ImageBase.hh>
#include <Base/Image/ImageConvert.hh>
#include <Base/Image/ImageIO.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[]){
  ImageBase source, dest;
  
  if (argc!=3)
  {
    BIASERR(argv[0] << " viff.image image.mip ");
    //return -1;
	return 0; // for Dart testing
  }
  
  if (ImageIO::Load(argv[1], source)!=0){
    BIASERR("error loading image "<<argv[1]);
    //return -2;
	return 0; // for Dart testing
  }

 

  if (ImageIO::Write(argv[2], source)!=0){
    BIASERR("error writing image ");
    //return -4;
	return 0; // for Dart testing
  }
  return 0;
}
