#include "bias_config.h"

///
/// solve explicit instantiation
/// this file is included by ImageConvert.cpp
/// @author Jan Woetzel
///

#define INSTANCE_ImageConvert(type)\
template BIASImageBase_EXPORT int ImageConvert::IP_ToGrey(Image<type> &img);\
template BIASImageBase_EXPORT int ImageConvert::ToGrey(const Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToRGB(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToHSV(Image<type>& source,Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToHSL(Image<type>& source,Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::TohsL(Image<type>& source,Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToInterleaved(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToInterleavedRGB(Image<type>& red, Image<type>& green, Image<type>& blue, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToPlanar(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::FromInterleaved(Image<type>& source, Image<type>& Image1, Image<type>& Image2, Image<type>& Image3);\
template BIASImageBase_EXPORT int ImageConvert::IP_RGBToGrey_(Image<type> &img);\
template BIASImageBase_EXPORT int ImageConvert::IP_YUV422ToGrey_(Image<type> &img);\
template BIASImageBase_EXPORT int ImageConvert::BGRToRGB_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::YUV422ToRGB_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::GreyToRGB_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::RGBToGrey_(const Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::HSLToGrey_(const Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::YUV422ToGrey_(const Image<type> &source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToPlanarYUYV422_(Image<type>& source, Image<type>& dest);    \
template BIASImageBase_EXPORT int ImageConvert::ToPlanarRGB_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToInterleavedYUYV422_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::ToInterleavedRGB_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::FromInterleavedYUYV422_(Image<type>& source, Image<type>& Y, Image<type>& U, Image<type>& V);\
template BIASImageBase_EXPORT int ImageConvert::FromInterleavedRGB_(Image<type>& source, Image<type>& R,  Image<type>& G, Image<type>& B);\
template BIASImageBase_EXPORT int ImageConvert::BayerToGrey_(const Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::BayerToRGB_(Image<type>& source, Image<type>& dest);\
template BIASImageBase_EXPORT int ImageConvert::BayerToRGBSlow_(Image<type>& source, Image<type>& dest);


#ifdef BIAS_HAVE_OPENCV
#define INSTANCE_ImageConvert_OPENCV(cvt)\
template BIASImageBase_EXPORT int ImageConvert::BIAS2ipl(const Image<cvt>& source, IplImage* &dest);\
template BIASImageBase_EXPORT int ImageConvert::Ipl2BIAS(IplImage* source, Image<cvt>& dest);
#else
#define INSTANCE_ImageConvert_OPENCV(cvt)
#endif


#ifdef BIAS_HAVE_DV
#define INSTANCE_ImageConvert_DV(dvtype)\
template BIASImageBase_EXPORT int ImageConvert::DVToRGB_(const Image<dvtype>& source, Image<dvtype>& dest,unsigned char quality);
#else 
#define INSTANCE_ImageConvert_DV(dvtype)
#endif





// all instances for one type: 
#define INSTI(atype)   INSTANCE_ImageConvert(atype) INSTANCE_ImageConvert_OPENCV(atype) INSTANCE_ImageConvert_DV(atype)


INSTI(unsigned char)
INSTI(float)
#ifdef BUILD_IMAGE_INT
INSTI(int)
#endif
#ifdef BUILD_IMAGE_CHAR
INSTI(char)
#endif
#ifdef BUILD_IMAGE_SHORT
INSTI(short)
#endif
#if defined(BUILD_IMAGE_USHORT)
INSTI(unsigned short)
#endif
#ifdef BUILD_IMAGE_DOUBLE
INSTI(double)
#endif
#ifdef BUILD_IMAGE_UINT
INSTI(unsigned int)
#endif

