#include <Geometry/Projection.hh>
#include <Geometry/ProjectionParametersSpherical.hh>
#include <iostream>

using namespace BIAS;
using namespace std;

int main (int argc, char* argv[])
{
  Projection proj1, proj2;
#ifdef BIAS_HAVE_XML2
  if (argc<2) {
    cout <<"no file given, terminating!"<<endl;
    exit(0);
  }
  else {
    if (proj1.XMLRead(argv[1])<0) {
      if (proj1.ReadFromCamParamFile(argv[1])<0) {
        cout << "Error reading file:" << argv[1] << endl;
        exit(0);
      }
    }
    cout << "Read file:" << argv[1] << endl;
  }
  
  cout <<"Projection is: "<<proj1<<endl;
  ProjectionParametersSpherical *pps =
    dynamic_cast<ProjectionParametersSpherical *> (proj1.GetParameters());

  //const ProjectionParametersSpherical* pPPS = 
  //   dynamic_cast<const ProjectionParametersSpherical*> proj1.GetParameters();
  KMatrix K1, K2, K3;
  double imgsize1,imgsize2, imgsize3;
  K1 = pps->GetFakeKMatrix(imgsize1,0);
  K2 = pps->GetFakeKMatrix(imgsize2,1);
  K3 = pps->GetFakeKMatrix(imgsize3,2);
  cout << "KMatNormal:" << imgsize1 << "x" << imgsize1 << K1 << endl;
  cout << "KMatBig:" <<    imgsize2 << "x" << imgsize1 << K2 << endl;
  cout << "KMatSmall:" <<  imgsize3 << "x" << imgsize1 << K3 << endl;
  string flat;
  proj1.XMLWriteToString(flat);
  cout <<"My Projection flat as string: "<<flat<<endl;
  proj1.XMLReadFromString(flat);
  proj1.XMLWrite("PassedThroughString.xml");
  

  cout <<"Externals: "<<proj1.GetParameters()->GetExternals()<<endl;
  HomgPoint3D p3d;
  HomgPoint2D p2d;

  p3d[0] = 10.0;  p3d[1] = 11.0;  p3d[2] = -10.0;  p3d[3] = 1.0;

  p2d = proj1.Project(p3d);
  cout <<p3d<<"  -> "<<p2d<<endl;

  proj1.XMLWrite("CamDataTest.xml");
  cout <<"CamDataTest.xml created" << endl;

  proj2.XMLRead("CamDataTest.xml");
  proj2.XMLWrite("CamDataTestRewrite.xml");
  cout <<"CamDataTestRewrite.xml created" << endl;


  


#endif
  return 0;  
}
