#include "CameraViewExternals.hh"
#include <iostream>
#include <Base/Debug/Error.hh>
#include <Base/Debug/DebugSimple.hh>

#ifdef BIAS_HAVE_OPENGL
#  include <Gui/biasgl.h>
#endif //BIAS_HAVE_OPENGL


using namespace std;
using namespace BIAS;


CameraViewExternals::CameraViewExternals()
{
  InitMembers();
}

CameraViewExternals::CameraViewExternals(const BIAS::Vector3<double> & vC,
                                         const BIAS::Vector3<double> & vup,
                                         const BIAS::Vector3<double> & vviewAt)
                                         : C(vC), up(vup), viewAt(vviewAt)
{}


std::ostream & BIAS::CameraViewExternals::Print(std::ostream & os)
{
  os<<"CameraViewExternals : "<<endl
    <<"C      "<<C<<endl
    <<"viewAt "<<viewAt<<endl
    <<"up     "<<up<<endl
    <<endl;
  return os;
}

#ifdef BIAS_HAVE_OPENGL
void BIAS::CameraViewExternals::DisplayGL() const
{
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity(); 
  gluLookAt(
    (GLdouble)C[0],
    (GLdouble)C[1],
    (GLdouble)C[2],
    (GLdouble)viewAt[0],
    (GLdouble)viewAt[1],
    (GLdouble)viewAt[2],
    (GLdouble)up[0],
    (GLdouble)up[1],
    (GLdouble)up[2] 
    );
}

void BIAS::CameraViewExternals::DisplayViewAt(const double & size) const
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glPushAttrib(GL_POINT_BIT);
  glPointSize(7);
  glColor3f(1.0, 0.0, 1.0);
  glBegin(GL_POINTS);
  glVertex3dv(&viewAt[0]);
  glEnd();
  glPopAttrib();
  glPopMatrix();
}
#endif // BIAS_HAVE_OPENGL

