#include "CameraViewInternals.hh"
#include <iostream>
#include <Base/Debug/Error.hh>
#include <Base/Debug/DebugSimple.hh>

using namespace std;
using namespace BIAS;

std::ostream & BIAS::CameraViewInternals::Print(std::ostream & os ) const 
{
  os<<"CameraViewInternals : "<<endl;
  frustum.Print(os);  os<<endl;
  viewport.Print(os); os<<endl;
  return os;
}

void BIAS::CameraViewInternals::InitMembers()
{
  frustum.InitMembers();
  viewport.InitMembers();
}

#ifdef BIAS_HAVE_OPENGL
#include <Gui/biasgl.h>
void BIAS::CameraViewInternals::DisplayGL() const
{
  frustum.DisplayGL();
  viewport.DisplayGL();
}
#endif // BIAS_HAVE_OPENGL

