#ifndef __CameraViewInternals_h__
#define __CameraViewInternals_h__

#include <bias_config.h>
#include <iostream>
#include <Gui/CameraViewFrustum.hh>
#include <Gui/CameraViewport.hh>


namespace BIAS {

  /** \brief describes internal params of an (OpenGL) camera view

  It is manipulated by controller classes.
  \author Jan Woetzel 09/2003 */
  class BIASGui_EXPORT CameraViewInternals {
  public:
    virtual ~CameraViewInternals(){}; ///< destructor

    // ctors
    CameraViewInternals(){}

    void InitMembers();

    std::ostream & Print(std::ostream & os=std::cout ) const;

#ifdef BIAS_HAVE_OPENGL
    void DisplayGL() const;
#endif //BIAS_HAVE_OPENGL

  public:
    CameraViewFrustum frustum;
    CameraViewport    viewport;

  }; // CameraViewInternals
} // namespace BIAS
#endif

