#ifndef __CameraViewport_h__
#define __CameraViewport_h__

#include <bias_config.h>
#include <iostream>


namespace BIAS {

  /** \brief describes internal parameter viewport of an (OpenGL) camera view

  \author Jan Woetzel 09/2003 */
  class BIASGui_EXPORT CameraViewport {
  public:
    virtual ~CameraViewport(){}; ///< destructor

    // ctors
    CameraViewport();

    CameraViewport(const int vx0, int vy0, unsigned int vwidth, unsigned int height );


    double GetAspect() const;

    std::ostream & Print(std::ostream & os=std::cout ) const;

    void InitMembers();

#ifdef BIAS_HAVE_OPENGL
    void DisplayGL() const;
#endif // BIAS_HAVE_OPENGL

  public:
    int x0; //< origin in scroen coords
    int y0;
    unsigned int width; //< dim in screen coords
    unsigned int height;

  }; // CameraViewFrustum




} // namespace BIAS
#endif
