/** Jan Woetzel 2005 */
#include "ConsoleRedirectIO.hh"

#ifdef WIN32
#  include <windows.h>
#  include <stdio.h>
#  include <fcntl.h>
#  include <io.h>
#  include <iostream>
#  include <fstream>
using namespace std;
// maximum number of lines the output console should have
#define CONSOLE_BUF_HEIGHT 1024;
#define CONSOLE_BUF_WIDTH  140;
#endif // WIN32


// JW 
void BIAS::ConsoleRedirectIO() 
{
#ifdef WIN32 
//#  ifdef _DEBUG

	//
	// open console window
	//
	int hConHandle=0;
	long lStdHandle=0;
	CONSOLE_SCREEN_BUFFER_INFO coninfo;
	FILE *fp=NULL;
	// allocate a console for this app
	AllocConsole();
	// set the screen buffer to be big enough to let us scroll text
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),	&coninfo);
	coninfo.dwSize.X = CONSOLE_BUF_WIDTH;
	coninfo.dwSize.Y = CONSOLE_BUF_HEIGHT;
	// buffer size
	SetConsoleScreenBufferSize(GetStdHandle(STD_OUTPUT_HANDLE),	coninfo.dwSize);

	//// position and window size:
	//coninfo.srWindow.Left=0;
	//coninfo.srWindow.Right=CONSOLE_BUF_WIDTH;
	//coninfo.srWindow.Top=0;
	//coninfo.srWindow.Bottom=75;
	//// window size and pos
	//SetConsoleWindowInfo(GetStdHandle(STD_OUTPUT_HANDLE), TRUE /*bAbsolute*/ , &coninfo.srWindow );

	// window title
	SetConsoleTitle("ConsoleRedirectIO");

	//
	// redirections
	//
	// redirect unbuffered STDOUT to the console
	lStdHandle = (long)GetStdHandle(STD_OUTPUT_HANDLE);
	hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
	fp = _fdopen( hConHandle, "w" );
	*stdout = *fp;
	setvbuf( stdout, NULL, _IONBF, 0 );

	// redirect unbuffered STDIN to the console
	lStdHandle = (long)GetStdHandle(STD_INPUT_HANDLE);
	hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
	fp = _fdopen( hConHandle, "r" );
	*stdin = *fp;
	setvbuf( stdin, NULL, _IONBF, 0 );

	// redirect unbuffered STDERR to the console
	lStdHandle = (long)GetStdHandle(STD_ERROR_HANDLE);
	hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
	fp = _fdopen( hConHandle, "w" );
	*stderr = *fp;
	setvbuf( stderr, NULL, _IONBF, 0 );

	// make cout, wcout, cin, wcin, wcerr, cerr, wclog and clog
	// point to console as well and output in correct order 
	ios::sync_with_stdio(true);

//#  endif // _DEBUG
#else // WIN32
	// Linux has no WinMain applications, do nothing. JW
#endif // WIN32
}

