#ifndef _bias_wx_glcanvas_h_
#define _bias_wx_glcanvas_h_



/** 
\brief wrapper for <wx/glcanvas.h> to include glxew soon enough
\author: Jan Woetzel
*/

#include <bias_config.h>
#include <Gui/biasgl.h>

#if !defined(BIAS_HAVE_WXWINDOWS) && !defined(MIP_HAVE_WXWINDOWS)
#error You need WX to compile. Please recompile BIAS and/or MIP with USE_WXWINDOWS.
#else // WX


// order is mandatory: include glew first to avoid redefinitions ! (JW)
// wxglcanvas includes glx.h, 
// thus we must include glxew first to avoid conflict in glew case
#if defined(BIAS_HAVE_GLEW) || defined(MIP_HAVE_GLEW) 
#  if !defined(WIN32)
#    include <GL/glxew.h>
#    define __glx_h__
#  endif // GLEW 
#endif // Linux
#include <wx/glcanvas.h> 

#endif //WX



#endif // _bias_wx_glcanvas_h_ 
// DO NOT ADD CODE AFTER THIS LINE

