
#include <bias_config.h>

#include <Image/CameraParam.hh>
#include <Image/UnVignette.hh>
#include <Base/Image/ImageIO.hh>
#include <iostream>
#include <Base/Debug/TimeMeasure.hh>


using namespace BIAS;
using namespace std;



int main(int argc, char** argv )
{
  if (argc<3 ) {
    cout <<"Usage: ExampleUnVignette <image> <CameraParam.xml>"<<endl;
    exit(0);
  }

  BIAS::CameraParam cParam;

  BIAS::Image<unsigned char> Image;
  BIAS::ImageIO::Load(argv[1],Image);
  int ret = cParam.ReadCameraData(argv[2]);
  if(ret < 0)
  {
    cout<<"Reading of CameraParams failed!"<<endl;
    exit(-1);
  }
  //parameter: CameraParam , useLuT 
  BIAS::UnVignette unVig(cParam,LEAST_SQUARES);
  BIAS::TimeMeasure timer;
  timer.Start();
  unVig.Compute(Image);
  timer.Stop();
  timer.PrintUserTime();
  BIAS::ImageIO::Write("ExampleUnVignetted.mip",Image);
  cout<<"Output image written to ExampleUnVignetted.mip."<<endl;
  return 0;  
}
