/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <bias_config.h>
#ifdef BIAS_HAVE_GSL
#include <Base/Math/Random.hh>
#include <MathAlgo/GSL.hh>

using namespace BIAS;
using namespace std;

int main(int /*argc*/, char ** /*argv*/ )
{
  Random rand;
  const int count=100;
  const int deg_freedom = 2;
  double x;
  
  for (int i=0; i<count; i++){
    x = rand.GetUniformDistributed(0.0, 1.0);
    cout << setw(13) << setprecision(3) << x
         << setw(13) << setprecision(3) 
         << InvChiSquareCulmProbFun(x, deg_freedom) << endl;
  }
  return 0;
}
#endif
