#include <Utils/ThreeDOut.hh>
#include <Geometry/Projection.hh>
#include <iostream>

using namespace std;
using namespace BIAS;

int main(int argc, char* argv[]) 
{
  if(argc<3) {
    cout<<"usage:\n";
    cout<<argv[0]<<" <projectionFile.xml> <ouputFile>\n";
    return -1;
  }

  
  Projection P;
  if(P.XMLRead(argv[1])!=0) {
    cout<<"could not read projection file!\n";
    return -1;
  }
  
  if(P.GetParameters() == NULL) {
    cout<<"Fatal error generating projection object!\n";
    return -1;
  }
  
  ThreeDOut vrmlWriter;
  vrmlWriter.AddProjection(P, RGBAuc(0, 255, 0, 0));
  
  vrmlWriter.VRMLOut(argv[2]);

  cout<<"finished\n";
  
  return 0;
}
