#include <VideoSource/VideoSource_Base.hh>
#include <VideoSource/VideoSource_Shm.hh>
//#include <Gui/GuiGTK.hh>
//#include <Gui/GuiEnhanced.hh>
#include <Base/Image/ImageIO.hh>
#include <Image/Camera.hh>
//BIAS::GuiEnhanced guie;

using namespace BIAS;
using namespace std;

bool done = false;
bool save = false;
int imgNo = 0;


int main( int argc, char *argv[])
{
  VideoSource *cam;
  Camera<unsigned char> pic;
  cam = new VideoSource_Shm;
  cam->SetDebugLevel(D_NET);
  // char c;
  int res;
  if (argc>1) {
	  cout <<"Using shared mem file: "<<argv[1]<<endl;
	  res = cam->OpenDevice(argv[1]);
  }
  else res = cam->OpenDevice();
  if (res <0) exit(1);
  res = cam->PreGrab();
  if (res <0) exit(1);
  cam->InitImage(pic);
 
  while(!done){
    cam->GrabSingle(pic);
    cout <<"Got Image: "<<pic.GetWidth()<<"x"<<pic.GetHeight()<<"x"<<
      pic.GetChannelCount()<<endl;

      char name[255];
      sprintf(name,"image_%04i.mip",imgNo);
      BIAS::ImageIO::ExportImage(name,pic,ImageIO::FF_ppm);
    imgNo++;
    }
  

  cam->PostGrab();
  cam->CloseDevice();

  delete cam;
  return 0;
}

 
