#include <VideoSource/VideoSource_Base.hh>
#include <VideoSource/VideoSource_Disk.hh>
#include <VideoSource/VideoSource_Shm.hh>

#ifdef BIAS_HAVE_DCAM
#  include <VideoSource/VideoSource_DCAM.hh>
#endif // BIAS_HAVE_DCAM

#include <Image/Camera.hh>
#include <iostream>

#include <VideoSource/VideoShMFeeder.hh>

using namespace std;
using namespace BIAS;


int main( int /*argc*/, char** /*argv*/)
{
  VideoSource *cam;
  std::vector<std::string>  filenames;
  filenames.push_back("pic.mip");

  cam = new VideoSource_Disk();
//#ifdef BIAS_HAVE_DCAM
//  cam = new VideoSource_DCAM();
//#endif // BIAS_HAVE_DCAM

  BIAS::Camera<unsigned char> pic;
  char title[100];

  sprintf(title,"Sending Picture");

  cam->OpenDevice(filenames);  
  //cam->OpenDevice();  
  cam->InitImage(pic);
  cam->PreGrab();
  cam->GrabSingle(pic);
  cout << "Image grab OK\n";

  VideoShMFeeder ShMFeeder;

  int i =0;  
  while(i<10000){
    cam->GrabSingle(pic);
    ShMFeeder.ProcessImage(&pic);
    i++;
    cout <<i<<endl;
   
  }
  cam->PostGrab();

  cam->CloseDevice();
  delete cam;
  return 0;
}

 
