#include <Image/Camera.hh>
#include <VideoSource/VideoSource_V4L.hh>
#include <Gui/GuiGTK.hh>
#include <unistd.h>
#include <Base/Image/ImageConvert.hh>
#include <Base/Image/ImageIO.hh>

BIAS::GuiGTK CamWin;

using namespace BIAS;
using namespace std;

void mainloop(VideoSource *cam)
{   
  bool done = false;
  char c;
  char title[100];
  struct timeval now;
  float fps;
  int i,savedframes; 
  long start=0, end;
  bool color,pause;
  Camera<unsigned char> pic,pic2;
  sprintf(title,"MyWindow");
  CamWin.SetTitle(title);
  pause = false;
  color = true;
  bool save=false;
  i = 1;
  savedframes = 0;  
  cam->InitImage(pic);
  pic.PrintHeader(cout);
  

  while (!done)
    { 
      
      gettimeofday(&now, NULL);
      end = start;
      start =  (now.tv_sec % 1000) * 1000 + (now.tv_usec / 1000);
      fps = 1.0 / (float)(start-end) * 1000.0 ;
      c = CamWin.CheckForKeyEvent();
      switch (c) {
      case 'q': 
        done = true;
        break;
      case ' ': 
        pause = !pause;	  
        break;
      case 'c': 
        color = !color;	    
        break;
      case 's': 
        save=true;
        break;
      }
      if (!pause) {
        cam->GrabSingle(pic);
        if (save) {
          ImageIO::Write("V4L_shot.mip",pic);
          save = false;
          cout <<endl<<"Save V4L_shot.mip"<<endl;
        }
        if (color)
          ImageConvert::ToRGB(pic,pic2);
        else
          ImageConvert::ToGrey(pic,pic2); 
        //if (i==10)
        //  pic2.ExportImage("Cam.pnm",MIP_pnm);
        CamWin.ShowImage(pic2);
        cout <<"Frame: "<<i<<"  Showing  fps: "<<fps<<"\r";
        cout.flush(); 
        i++;
      }
    }
}







int main(int argc, char *argv[])
{
  int res;
  int channel = -1;
 
  VideoSource_V4L *cam;
  CamWin.InitGtk(&argc,&argv);


  // prepare camera




  cout <<"Using V4L with device /dev/video";
  if (argc==2) 
    channel = atoi(argv[1]);
  
  cout <<" Channel: "<<channel<<endl;

  cam = new VideoSource_V4L;
  //  cam->ShowCapabilities();
  cam->SetChannel(channel);
  //  cam->SetDebugLevel( D_V4L);

  //   cam->SetSize(720,576);  //Pal
  cam->SetColorModel(ImageBase::CM_BGR);
//   cam->SetColorModel(ImageBase::CM_YUYV422);
//    cam->SetColorModel(ImageBase::CM_BGR);

  // cam->SetColorModel(ImageBase::CM_YUV420P);
   //  cam->SetSize(640,480);  // WebCam

  res = cam->OpenDevice();

  cout <<"Openresult: "<<res<<endl;
  
  if (res <0) {
    cerr<<" Can not open camera"<<endl;
    exit(1);
  }
  
  // cam->ShowCapabilities();

   cam->PreGrab();

   
  cout <<" g  : Auto Gain ON\n";
  cout <<" G  : Auto Gain OFF\n";
  cout <<" c  : Color/Grey \n";
  cout <<"SPC : Stop/Resume\n";
  cout <<"  q : Quit      \n";


    mainloop(cam );
  
 
  
  cam->PostGrab();
 

  

   cam->CloseDevice();
   delete cam;
  
  return 0;
  
}
